unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, OleCtrls, ACTIVEVOICEPROJECTLib_TLB, ComCtrls,
  Buttons, Menus, ToolWin, ExtCtrls, ImgList;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Exit1: TMenuItem;
    N1: TMenuItem;
    SaveAs1: TMenuItem;
    Save1: TMenuItem;
    Open1: TMenuItem;
    New1: TMenuItem;
    Help1: TMenuItem;
    About1: TMenuItem;
    StatusBar1: TStatusBar;
    Panel1: TPanel;
    RichEdit1: TRichEdit;
    Panel2: TPanel;
    EditSpeed: TEdit;
    TrackBarSpeed: TTrackBar;
    lstEngine: TComboBox;
    TrackBarPitch: TTrackBar;
    EditPitch: TEdit;
    DirectSS: TDirectSS;
    ToolBar1: TToolBar;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    ToolButton4: TToolButton;
    ToolButton5: TToolButton;
    ToolButton6: TToolButton;
    N2: TMenuItem;
    N3: TMenuItem;
    N4: TMenuItem;
    N5: TMenuItem;
    N6: TMenuItem;
    ImageList1: TImageList;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    FontDialog1: TFontDialog;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    EditVolume: TEdit;
    TrackBarVolume: TTrackBar;
    N7: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure TrackBarSpeedChange(Sender: TObject);
    procedure TrackBarPitchChange(Sender: TObject);
    procedure ToolButton2Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure ToolButton4Click(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
    procedure lstEngineChange(Sender: TObject);
    procedure TrackBarVolumeChange(Sender: TObject);
  private
  procedure ReSelestEngineParametrs(Engine : Integer);  { Private declarations }
  procedure RefreshEngineParametrs ();
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  vEngines : Integer;
implementation

uses Math;

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
var  Count: Integer;
begin
vEngines := DirectSS.CountEngines; //     
Count := 1;
for Count:= 1 to vEngines do
  begin
  lstEngine.AddItem(DirectSS.ModeName(Count),lstEngine)
  end;
lstEngine.ItemIndex := 0;
ReSelestEngineParametrs(lstEngine.ItemIndex);
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
DirectSS.Select(lstEngine.ItemIndex);
DirectSS.Speed := TrackBarSpeed.Position;
DirectSS.Pitch := TrackBarPitch.Position;
DirectSS.Speak(Memo1.Text);
end;

procedure TForm1.TrackBarSpeedChange(Sender: TObject);
begin
EditSpeed.Text := IntToStr(TrackBarSpeed.Position);
end;

procedure TForm1.TrackBarPitchChange(Sender: TObject);
begin
EditPitch.Text := IntToStr(TrackBarPitch.Position);
end;

procedure TForm1.ToolButton2Click(Sender: TObject);
begin
RichEdit1.Text := '';
Caption:= '';
end;

procedure TForm1.Exit1Click(Sender: TObject);
begin
Close;
end;

procedure TForm1.ToolButton4Click(Sender: TObject);
begin
With OpenDialog1 Do
      If Execute Then
       begin
        //RichEdit1.PlainText := True;
        RichEdit1.PlainText := False;
        RichEdit1.Lines.LoadFromFile(FileName);
        //HistoryList.Add(FileName);
        Caption:= ' '+
        ExtractFileName(FileName);
        SaveDialog1.Filename:= FileName;
        FileName:= '';
        //mnuSave.Enabled := True; //   
        //ToolButton3.Enabled :=True; //  
       end;
end;

procedure TForm1.About1Click(Sender: TObject);
begin
Application.MessageBox(''+#13#10+'Copyright (c) 2003',
' ', MB_ICONINFORMATION);

end;

procedure TForm1.SpeedButton1Click(Sender: TObject);
var
R_text : string;
R_buffer : string;
begin
RefreshEngineParametrs();
R_text:=RichEdit1.Text;
Memo1.Text:=R_text;
DirectSS.Speak(Memo1.Text);
end;

procedure TForm1.SpeedButton2Click(Sender: TObject);
var Pause: Boolean;
begin
//If Pause=true then
//DirectSS.AudioPause()
//Pause:=false
//else
//DirectSS.AudioResume()
end;

procedure TForm1.SpeedButton3Click(Sender: TObject);
begin
DirectSS.AudioReset();
end;

procedure TForm1.lstEngineChange(Sender: TObject);
begin
ReSelestEngineParametrs(lstEngine.ItemIndex);
end;

procedure TForm1.ReSelestEngineParametrs(Engine: Integer);
begin
DirectSS.Select(Engine);
TrackBarSpeed.Max := DirectSS.MaxSpeed;
TrackBarSpeed.Min := DirectSS.MinSpeed;
TrackBarPitch.Max := DirectSS.MaxPitch;
TrackBarPitch.Min := DirectSS.MinPitch;
TrackBarVolume.Min := DirectSS.MinVolumeRight;
TrackBarVolume.Max := DirectSS.MaxVolumeRight;

TrackBarSpeed.Position := DirectSS.MinSpeed;
TrackBarPitch.Position := DirectSS.MinPitch;
TrackBarVolume.Position := DirectSS.MaxVolumeRight;

DirectSS.Speed := DirectSS.MinSpeed;
DirectSS.Pitch := DirectSS.MinPitch;
DirectSS.VolumeRight := DirectSS.MaxVolumeRight;
DirectSS.VolumeLeft := DirectSS.MaxVolumeRight;
end;

procedure TForm1.RefreshEngineParametrs();
begin
DirectSS.Speed := TrackBarSpeed.Position;
DirectSS.Pitch := TrackBarPitch.Position;
DirectSS.VolumeRight := TrackBarVolume.Position;
end;

procedure TForm1.TrackBarVolumeChange(Sender: TObject);
begin
EditVolume.Text := IntToStr(TrackBarVolume.Position);
end;

end.
